import Encrypt from "./crypto.js";
let BASE_URL = '';
//  BASE_URL = 'https://www.black-pa.com:5500/pro';	//线上正式
 // BASE_URL = 'https://www.black-pa.com:5500/dev';	//线上开发
 BASE_URL = 'https://www.black-pa.com:5500/test';	//线上测试

 // BASE_URL = 'https://bpa.black-pa.com:21527';	//本地开发
 // BASE_URL = 'https://bpa.black-pa.com:21528';	//本地测试

const Franchisee = '/kitchen';								//加盟商：0
const Order = '/order';										//订单： 1
const Pay = '/wechat/';										//支付:	2

const accountInfo = uni.getAccountInfoSync();
if (accountInfo.miniProgram.envVersion === 'trial') {
	BASE_URL = 'https://www.black-pa.com:5500/test';	
} else if (accountInfo.miniProgram.envVersion === 'release') {
	BASE_URL = 'https://www.black-pa.com:5500/pro';	
}

const request = (options) => {
	let BlackApp = Encrypt(`[${options.url}]_[${new Date().getTime()}]`);
	let interfaceType = '';
	switch(options.interfaceType) {
		case 0:
			interfaceType = Franchisee;
		break;
		case 1:
			interfaceType = Order;
		break;
		case 2:
			interfaceType = Pay;
		break;
	}
	if (interfaceType === '') {
		console.error('接口访问类型不能为空');
		return;
	}
	return new Promise((resolve, reject) => {
		uni.showLoading({
			title: '加载中',
			mask: true
		});
		uni.request({
			url: BASE_URL + interfaceType  + options.url,
			method: options.method || 'GET',
			data: options.data || {},
			header: options.header || {
				'BlackApp': BlackApp,
				'AppId': getApp().globalData.appId,
				'TenantId': getApp().globalData.companyId
			},
			timeout: 20000,
			success: response => {
				let jsonData = {
					data: null,
					isSuccess: false,
					msg: '服务端出现了问题！'
				}
				if (response.statusCode === 404) {
					jsonData.msg = '请求资源不存在';
					resolve(jsonData);
				} else if (response.statusCode === 502) {
					jsonData.msg = '服务端出现了问题';
					resolve(jsonData);
				} else if (response.statusCode === 403) {
					jsonData.msg = '没有权限访问';
					resolve(jsonData);
				} else if (response.statusCode === 200) {
					resolve(response.data);
				} else {
					resolve(jsonData);
				}
			},
			fail: error => {
				let response = {
					data: null,
					isSuccess: false,
					msg: '服务端问题' + JSON.stringify(error.errMsg)
				}
				console.log('服务端问题', error);
				resolve(response);
			},
			complete: () => {
				uni.hideLoading();
			}
		});
	});
}

export default request;